Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 786543 - media-sound/ogmtools-1.5-r2: fails to build with GCC 11 due to default -std=c++17 (error: ISO C++17 does not allow dynamic exception specifications)
Summary: media-sound/ogmtools-1.5-r2: fails to build with GCC 11 due to default -std=c...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: AMD64 Linux
: Normal normal (vote)
Assignee: Gentoo Sound Team
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks: gcc-11
  Show dependency tree
 
Reported: 2021-04-28 19:48 UTC by Alexandra Parker
Modified: 2021-04-29 22:03 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,335.38 KB, text/plain)
2021-04-28 20:06 UTC, Alexandra Parker
Details
ogmtools-1.5-remove-dynamic-exception-specs.patch (ogmtools-1.5-remove-dynamic-exception-specs.patch,16.27 KB, patch)
2021-04-29 17:49 UTC, Matt Whitlock
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Alexandra Parker 2021-04-28 19:48:47 UTC
emerge ogmtools fails with errors like this:

In file included from r_ac3.cpp:25:
queue.h:39:11: error: ISO C++17 does not allow dynamic exception specifications
   39 |     q_c() throw (error_c);
      |           ^~~~~

Reproducible: Always

Steps to Reproduce:
1. Merge and select GCC 11 as your compiler
2. emerge ogmtools
Actual Results:  
Fails with a compile error.

Expected Results:  
Should have built successfully.

Forcing -std=c++14 into CXXFLAGS using the package.env mechanism works around the issue.
Comment 1 Alexandra Parker 2021-04-28 19:49:50 UTC
Portage 3.0.18 (python 3.9.4-final-0, default/linux/amd64/17.1/desktop/gnome/systemd, gcc-11.1.0, glibc-2.33, 5.12.0-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-5.12.0-gentoo-x86_64-Intel-R-_Core-TM-_i7-3770_CPU_@_3.40GHz-with-glibc2.33
KiB Mem:    16362364 total,   7215616 free
KiB Swap:   16777212 total,  16761340 free
Timestamp of repository gentoo: Wed, 28 Apr 2021 05:05:31 +0000
Head commit of repository gentoo: f05272f58cd01074e4ceb46d4f8b39dedb93feb9

Head commit of repository xandris: 930580171cfd3774c6c1937a578151f9899e7ee4

sh bash 5.1_p4
ld GNU ld (Gentoo 2.36.1 p3) 2.36.1
distcc 3.3.3 x86_64-pc-linux-gnu [disabled]
ccache version 4.2.1 [enabled]
app-shells/bash:          5.1_p4::gentoo
dev-java/java-config:     2.3.1::gentoo
dev-lang/perl:            5.32.1::gentoo
dev-lang/python:          3.8.9::gentoo, 3.9.4::gentoo
dev-lang/rust:            1.51.0-r2::gentoo
dev-util/ccache:          4.2.1::gentoo
dev-util/cmake:           3.20.1::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.7-r2::gentoo
sys-apps/sandbox:         2.23::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r5::gentoo
sys-devel/automake:       1.16.3-r1::gentoo
sys-devel/binutils:       2.36.1-r1::gentoo
sys-devel/gcc:            11.1.0::gentoo
sys-devel/gcc-config:     2.4::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.12::gentoo (virtual/os-headers)
sys-libs/glibc:           2.33::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: https://github.com/gentoo-mirror/gentoo.git
    sync-user: portage:portage
    priority: -1000
    sync-git-verify-commit-signature: true

x-portage
    location: /usr/local/portage
    masters: gentoo
    priority: 0

xandris
    location: /var/db/repos/xandris
    sync-type: git
    sync-uri: https://github.com/xandris/overlay.git
    sync-user: portage:portage
    masters: gentoo

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -pipe  -march=ivybridge -mtune=ivybridge -maes   -O3 -fgcse-sm -fgcse-las -fgraphite -fgraphite-identity -floop-nest-optimize -ftree-vectorize -fvariable-expansion-in-unroller -fstack-protector-strong -fno-lto "
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /etc/grs/systems.conf /etc/stunnel/stunnel.conf /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt /var/ossec/etc"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php8.0/ext-active/ /etc/php/cgi-php8.0/ext-active/ /etc/php/cli-php8.0/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -pipe  -march=ivybridge -mtune=ivybridge -maes   -O3 -fgcse-sm -fgcse-las -fgraphite -fgraphite-identity -floop-nest-optimize -ftree-vectorize -fvariable-expansion-in-unroller -fstack-protector-strong -fno-lto "
DISTDIR="/var/portage/distfiles"
EMERGE_DEFAULT_OPTS="     --jobs=3     --load-average=8.1     --keep-going     --quiet-fail y     --quiet-repo-display "
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance ccache cgroup clean-logs compressdebug config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict news parallel-fetch parallel-install preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms splitdebug strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="rsync://gentoo.gossamerhost.com/gentoo-distfiles/ ftp://mirror.netcologne.de/gentoo/"
LANG="en_US.UTF-8"
LDFLAGS="-O2 -pipe -pipe  -march=ivybridge -mtune=ivybridge -maes   -O3 -fgcse-sm -fgcse-las -fgraphite -fgraphite-identity -floop-nest-optimize -ftree-vectorize -fvariable-expansion-in-unroller -fstack-protector-strong -fno-lto  -Wl,-O1,--sort-common,--hash-style=gnu,--as-needed,-z,now -fno-lto"
LINGUAS="en ja"
MAKEOPTS="-j9 -l7"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acoustid acpi alsa amd64 ao archive audiofile avahi berkdb bluetooth branding bzip2 cairo cdda cddb cdr cjk cli colord crypt cups curl dbus dc1394 dri dts dvd dvdr eds emboss encode evo exif faac faad firefox flac fortran fuse gdbm gif gnome gnome-keyring gnome-online-accounts gnutls gphoto2 gpm gstreamer gtk gtkhtml gui iconv icu ieee1394 introspection ipv6 jpeg jpeg2k lcms leim libglvnd libnotify libsamplerate libsecret libtirpc libv4l lm_sensors lzma mad matroska mikmod mmap mng modplug mp3 mp4 mpeg multilib musepack nautilus ncurses networkmanager nls nptl offensive ogg opengl openmp pam pango pcre pdf png policykit postproc ppds pulseaudio qt5 readline samba schroedinger sdl seccomp slang sndfile speex spell split-usr ssl startup-notification svg sysprof systemd tcpd theora threads tiff tracker truetype udev udisks unicode upnp upower usb v4l vaapi vdpau vorbis vpx winbind wxwidgets x264 xattr xcb xcomposite xinerama xml xv xvid xvmc zlib" ABI_X86="64" ADA_TARGET="gnat_2018" APACHE2_MODULES="actions alias auth_digest authn_anon authn_file authz_dbm authz_groupfile authz_host authz_owner authz_user autoindex cache deflate dir env expires ext_filter file_cache filter headers ident include info log_config logio mime mime_magic negotiation proxy proxy_http rewrite setenvif status authn_core authz_core unixd socache_shmcb slotmem_shm" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx f16c mmx mmxext pclmul popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" CURL_SSL="openssl" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev" KERNEL="linux" L10N="en ja" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LLVM_TARGETS="BPF NVPTX WebAssembly" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9" RUBY_TARGETS="ruby30 ruby27" USERLAND="GNU" VIDEO_CARDS="vga vesa nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RUSTFLAGS

=================================================================
                        Package Settings
=================================================================

media-sound/ogmtools-1.5-r2::gentoo was built with the following:
USE="dvd" ABI_X86="(64)"
CXXFLAGS="-O2 -pipe -pipe -march=ivybridge -mtune=ivybridge -maes -O3 -fgcse-sm -fgcse-las -fgraphite -fgraphite-identity -floop-nest-optimize -ftree-vectorize -fvariable-expansion-in-unroller -fstack-protector-strong -fno-lto --std=c++14"
Comment 2 Sam James archtester gentoo-dev Security 2021-04-28 19:54:59 UTC
Please always attach the full build.log too
Comment 3 Alexandra Parker 2021-04-28 20:06:07 UTC
Created attachment 703470 [details]
build.log

sorry for the delay, multitasking
Comment 4 Sam James archtester gentoo-dev Security 2021-04-28 20:15:18 UTC
np :)
Comment 5 Matt Whitlock 2021-04-29 17:49:28 UTC
Created attachment 704016 [details, diff]
ogmtools-1.5-remove-dynamic-exception-specs.patch

The attached patch removes the offending dynamic exception specifications and allows media-sound/ogmtools-1.5-r2 to build successfully with GCC 11.1.0.
Comment 6 Larry the Git Cow gentoo-dev 2021-04-29 22:03:52 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=50f6532b2a846a2576f69858d0ad5bf70bf54cf1

commit 50f6532b2a846a2576f69858d0ad5bf70bf54cf1
Author:     David Seifert <soap@gentoo.org>
AuthorDate: 2021-04-29 22:03:39 +0000
Commit:     David Seifert <soap@gentoo.org>
CommitDate: 2021-04-29 22:03:39 +0000

    media-sound/ogmtools: Fix building against GCC 11
    
    Closes: https://bugs.gentoo.org/786543
    Package-Manager: Portage-3.0.18, Repoman-3.0.3
    Suggested-by: Matt Whitlock <gentoo@mattwhitlock.name>
    Signed-off-by: David Seifert <soap@gentoo.org>

 .../ogmtools/files/ogmtools-1.5-gcc11.patch        | 374 +++++++++++++++++++++
 media-sound/ogmtools/ogmtools-1.5-r2.ebuild        |   3 +-
 2 files changed, 376 insertions(+), 1 deletion(-)